/**
 * Lombongo core API (for Javascript) 0.1.60.
 *
 * Copyright (c) 2023 Lombongo .
 *
 * This source code is licensed under the Apache 2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.lombongo = {}));
})(this, (function (exports) { 'use strict';

  function _iterableToArrayLimit(arr, i) {
    var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"];
    if (null != _i) {
      var _s,
        _e,
        _x,
        _r,
        _arr = [],
        _n = !0,
        _d = !1;
      try {
        if (_x = (_i = _i.call(arr)).next, 0 === i) {
          if (Object(_i) !== _i) return;
          _n = !1;
        } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0);
      } catch (err) {
        _d = !0, _e = err;
      } finally {
        try {
          if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return;
        } finally {
          if (_d) throw _e;
        }
      }
      return _arr;
    }
  }
  function _regeneratorRuntime() {
    _regeneratorRuntime = function () {
      return exports;
    };
    var exports = {},
      Op = Object.prototype,
      hasOwn = Op.hasOwnProperty,
      defineProperty = Object.defineProperty || function (obj, key, desc) {
        obj[key] = desc.value;
      },
      $Symbol = "function" == typeof Symbol ? Symbol : {},
      iteratorSymbol = $Symbol.iterator || "@@iterator",
      asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
      toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
    function define(obj, key, value) {
      return Object.defineProperty(obj, key, {
        value: value,
        enumerable: !0,
        configurable: !0,
        writable: !0
      }), obj[key];
    }
    try {
      define({}, "");
    } catch (err) {
      define = function (obj, key, value) {
        return obj[key] = value;
      };
    }
    function wrap(innerFn, outerFn, self, tryLocsList) {
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
        generator = Object.create(protoGenerator.prototype),
        context = new Context(tryLocsList || []);
      return defineProperty(generator, "_invoke", {
        value: makeInvokeMethod(innerFn, self, context)
      }), generator;
    }
    function tryCatch(fn, obj, arg) {
      try {
        return {
          type: "normal",
          arg: fn.call(obj, arg)
        };
      } catch (err) {
        return {
          type: "throw",
          arg: err
        };
      }
    }
    exports.wrap = wrap;
    var ContinueSentinel = {};
    function Generator() {}
    function GeneratorFunction() {}
    function GeneratorFunctionPrototype() {}
    var IteratorPrototype = {};
    define(IteratorPrototype, iteratorSymbol, function () {
      return this;
    });
    var getProto = Object.getPrototypeOf,
      NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function (method) {
        define(prototype, method, function (arg) {
          return this._invoke(method, arg);
        });
      });
    }
    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);
        if ("throw" !== record.type) {
          var result = record.arg,
            value = result.value;
          return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
            invoke("next", value, resolve, reject);
          }, function (err) {
            invoke("throw", err, resolve, reject);
          }) : PromiseImpl.resolve(value).then(function (unwrapped) {
            result.value = unwrapped, resolve(result);
          }, function (error) {
            return invoke("throw", error, resolve, reject);
          });
        }
        reject(record.arg);
      }
      var previousPromise;
      defineProperty(this, "_invoke", {
        value: function (method, arg) {
          function callInvokeWithMethodAndArg() {
            return new PromiseImpl(function (resolve, reject) {
              invoke(method, arg, resolve, reject);
            });
          }
          return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
        }
      });
    }
    function makeInvokeMethod(innerFn, self, context) {
      var state = "suspendedStart";
      return function (method, arg) {
        if ("executing" === state) throw new Error("Generator is already running");
        if ("completed" === state) {
          if ("throw" === method) throw arg;
          return doneResult();
        }
        for (context.method = method, context.arg = arg;;) {
          var delegate = context.delegate;
          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);
            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }
          if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
            if ("suspendedStart" === state) throw state = "completed", context.arg;
            context.dispatchException(context.arg);
          } else "return" === context.method && context.abrupt("return", context.arg);
          state = "executing";
          var record = tryCatch(innerFn, self, context);
          if ("normal" === record.type) {
            if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
            return {
              value: record.arg,
              done: context.done
            };
          }
          "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
        }
      };
    }
    function maybeInvokeDelegate(delegate, context) {
      var methodName = context.method,
        method = delegate.iterator[methodName];
      if (undefined === method) return context.delegate = null, "throw" === methodName && delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method) || "return" !== methodName && (context.method = "throw", context.arg = new TypeError("The iterator does not provide a '" + methodName + "' method")), ContinueSentinel;
      var record = tryCatch(method, delegate.iterator, context.arg);
      if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
      var info = record.arg;
      return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
    }
    function pushTryEntry(locs) {
      var entry = {
        tryLoc: locs[0]
      };
      1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
    }
    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal", delete record.arg, entry.completion = record;
    }
    function Context(tryLocsList) {
      this.tryEntries = [{
        tryLoc: "root"
      }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
    }
    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) return iteratorMethod.call(iterable);
        if ("function" == typeof iterable.next) return iterable;
        if (!isNaN(iterable.length)) {
          var i = -1,
            next = function next() {
              for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;
              return next.value = undefined, next.done = !0, next;
            };
          return next.next = next;
        }
      }
      return {
        next: doneResult
      };
    }
    function doneResult() {
      return {
        value: undefined,
        done: !0
      };
    }
    return GeneratorFunction.prototype = GeneratorFunctionPrototype, defineProperty(Gp, "constructor", {
      value: GeneratorFunctionPrototype,
      configurable: !0
    }), defineProperty(GeneratorFunctionPrototype, "constructor", {
      value: GeneratorFunction,
      configurable: !0
    }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
      var ctor = "function" == typeof genFun && genFun.constructor;
      return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
    }, exports.mark = function (genFun) {
      return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
    }, exports.awrap = function (arg) {
      return {
        __await: arg
      };
    }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
      return this;
    }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
      void 0 === PromiseImpl && (PromiseImpl = Promise);
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
      return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
        return result.done ? result.value : iter.next();
      });
    }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
      return this;
    }), define(Gp, "toString", function () {
      return "[object Generator]";
    }), exports.keys = function (val) {
      var object = Object(val),
        keys = [];
      for (var key in object) keys.push(key);
      return keys.reverse(), function next() {
        for (; keys.length;) {
          var key = keys.pop();
          if (key in object) return next.value = key, next.done = !1, next;
        }
        return next.done = !0, next;
      };
    }, exports.values = values, Context.prototype = {
      constructor: Context,
      reset: function (skipTempReset) {
        if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
      },
      stop: function () {
        this.done = !0;
        var rootRecord = this.tryEntries[0].completion;
        if ("throw" === rootRecord.type) throw rootRecord.arg;
        return this.rval;
      },
      dispatchException: function (exception) {
        if (this.done) throw exception;
        var context = this;
        function handle(loc, caught) {
          return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
        }
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i],
            record = entry.completion;
          if ("root" === entry.tryLoc) return handle("end");
          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc"),
              hasFinally = hasOwn.call(entry, "finallyLoc");
            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            } else {
              if (!hasFinally) throw new Error("try statement without catch or finally");
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            }
          }
        }
      },
      abrupt: function (type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }
        finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
        var record = finallyEntry ? finallyEntry.completion : {};
        return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
      },
      complete: function (record, afterLoc) {
        if ("throw" === record.type) throw record.arg;
        return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
      },
      finish: function (finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
        }
      },
      catch: function (tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;
            if ("throw" === record.type) {
              var thrown = record.arg;
              resetTryEntry(entry);
            }
            return thrown;
          }
        }
        throw new Error("illegal catch attempt");
      },
      delegateYield: function (iterable, resultName, nextLoc) {
        return this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
      }
    }, exports;
  }
  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }
    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }
  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
        args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }
        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }
        _next(undefined);
      });
    };
  }
  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor);
    }
  }
  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    Object.defineProperty(Constructor, "prototype", {
      writable: false
    });
    return Constructor;
  }
  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    Object.defineProperty(subClass, "prototype", {
      writable: false
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }
  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }
  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };
    return _setPrototypeOf(o, p);
  }
  function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;
    try {
      Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }
  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
  }
  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    } else if (call !== void 0) {
      throw new TypeError("Derived constructors may only return object or undefined");
    }
    return _assertThisInitialized(self);
  }
  function _createSuper(Derived) {
    var hasNativeReflectConstruct = _isNativeReflectConstruct();
    return function _createSuperInternal() {
      var Super = _getPrototypeOf(Derived),
        result;
      if (hasNativeReflectConstruct) {
        var NewTarget = _getPrototypeOf(this).constructor;
        result = Reflect.construct(Super, arguments, NewTarget);
      } else {
        result = Super.apply(this, arguments);
      }
      return _possibleConstructorReturn(this, result);
    };
  }
  function _superPropBase(object, property) {
    while (!Object.prototype.hasOwnProperty.call(object, property)) {
      object = _getPrototypeOf(object);
      if (object === null) break;
    }
    return object;
  }
  function _get() {
    if (typeof Reflect !== "undefined" && Reflect.get) {
      _get = Reflect.get.bind();
    } else {
      _get = function _get(target, property, receiver) {
        var base = _superPropBase(target, property);
        if (!base) return;
        var desc = Object.getOwnPropertyDescriptor(base, property);
        if (desc.get) {
          return desc.get.call(arguments.length < 3 ? target : receiver);
        }
        return desc.value;
      };
    }
    return _get.apply(this, arguments);
  }
  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
  }
  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }
  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }
  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
    return arr2;
  }
  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  function _createForOfIteratorHelper(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
    if (!it) {
      if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
        if (it) o = it;
        var i = 0;
        var F = function () {};
        return {
          s: F,
          n: function () {
            if (i >= o.length) return {
              done: true
            };
            return {
              done: false,
              value: o[i++]
            };
          },
          e: function (e) {
            throw e;
          },
          f: F
        };
      }
      throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }
    var normalCompletion = true,
      didErr = false,
      err;
    return {
      s: function () {
        it = it.call(o);
      },
      n: function () {
        var step = it.next();
        normalCompletion = step.done;
        return step;
      },
      e: function (e) {
        didErr = true;
        err = e;
      },
      f: function () {
        try {
          if (!normalCompletion && it.return != null) it.return();
        } finally {
          if (didErr) throw err;
        }
      }
    };
  }
  function _toPrimitive(input, hint) {
    if (typeof input !== "object" || input === null) return input;
    var prim = input[Symbol.toPrimitive];
    if (prim !== undefined) {
      var res = prim.call(input, hint || "default");
      if (typeof res !== "object") return res;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return (hint === "string" ? String : Number)(input);
  }
  function _toPropertyKey(arg) {
    var key = _toPrimitive(arg, "string");
    return typeof key === "symbol" ? key : String(key);
  }

  var AccountAPI = function AccountAPI(superclass) {
    return /*#__PURE__*/function (_superclass) {
      _inherits(_class, _superclass);
      var _super = _createSuper(_class);
      function _class() {
        _classCallCheck(this, _class);
        return _super.apply(this, arguments);
      }
      _createClass(_class, [{
        key: "sendMoney",
        value: function () {
          var _sendMoney = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
            var _ref,
              amount,
              accountNumber,
              recieverAccount,
              deviceFingerprint,
              url,
              options,
              response,
              _args = arguments;
            return _regeneratorRuntime().wrap(function _callee$(_context) {
              while (1) switch (_context.prev = _context.next) {
                case 0:
                  _ref = _args.length > 0 && _args[0] !== undefined ? _args[0] : {}, amount = _ref.amount, accountNumber = _ref.accountNumber, recieverAccount = _ref.recieverAccount, deviceFingerprint = _ref.deviceFingerprint;
                  url = "".concat(this.baseUrl, "/accounts/").concat(recieverAccount, "/send");
                  options = {
                    params: {
                      amount: amount,
                      account_number: accountNumber,
                      deviceFingerprint: deviceFingerprint
                    }
                  };
                  _context.next = 5;
                  return this.post(url, options);
                case 5:
                  response = _context.sent;
                  return _context.abrupt("return", response);
                case 7:
                case "end":
                  return _context.stop();
              }
            }, _callee, this);
          }));
          function sendMoney() {
            return _sendMoney.apply(this, arguments);
          }
          return sendMoney;
        }()
      }, {
        key: "avatar",
        value: function () {
          var _avatar = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(uid) {
            var url, response;
            return _regeneratorRuntime().wrap(function _callee2$(_context2) {
              while (1) switch (_context2.prev = _context2.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/account/").concat(uid, "/avatar");
                  _context2.next = 3;
                  return this.get(url);
                case 3:
                  response = _context2.sent;
                  return _context2.abrupt("return", response);
                case 5:
                case "end":
                  return _context2.stop();
              }
            }, _callee2, this);
          }));
          function avatar(_x) {
            return _avatar.apply(this, arguments);
          }
          return avatar;
        }()
      }, {
        key: "attachCreditCard",
        value: function () {
          var _attachCreditCard = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(card) {
            var url, options, response;
            return _regeneratorRuntime().wrap(function _callee3$(_context3) {
              while (1) switch (_context3.prev = _context3.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/account/credit-card/attach");
                  options = {
                    params: {
                      name: card.name,
                      number: card.number,
                      exp_month: card.expMonth,
                      exp_year: card.exp_year,
                      cvc: card.cvc,
                      commission: card.commission
                    }
                  };
                  _context3.next = 4;
                  return this.post(url, options);
                case 4:
                  response = _context3.sent;
                  return _context3.abrupt("return", response);
                case 6:
                case "end":
                  return _context3.stop();
              }
            }, _callee3, this);
          }));
          function attachCreditCard(_x2) {
            return _attachCreditCard.apply(this, arguments);
          }
          return attachCreditCard;
        }()
      }]);
      return _class;
    }(superclass);
  };

  var global$1 = typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {};

  // shim for using process in browser
  // based off https://github.com/defunctzombie/node-process/blob/master/browser.js

  function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
  }
  function defaultClearTimeout() {
    throw new Error('clearTimeout has not been defined');
  }
  var cachedSetTimeout = defaultSetTimout;
  var cachedClearTimeout = defaultClearTimeout;
  if (typeof global$1.setTimeout === 'function') {
    cachedSetTimeout = setTimeout;
  }
  if (typeof global$1.clearTimeout === 'function') {
    cachedClearTimeout = clearTimeout;
  }
  function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
      //normal enviroments in sane situations
      return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
      cachedSetTimeout = setTimeout;
      return setTimeout(fun, 0);
    }
    try {
      // when when somebody has screwed with setTimeout but no I.E. maddness
      return cachedSetTimeout(fun, 0);
    } catch (e) {
      try {
        // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
        return cachedSetTimeout.call(null, fun, 0);
      } catch (e) {
        // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
        return cachedSetTimeout.call(this, fun, 0);
      }
    }
  }
  function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
      //normal enviroments in sane situations
      return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
      cachedClearTimeout = clearTimeout;
      return clearTimeout(marker);
    }
    try {
      // when when somebody has screwed with setTimeout but no I.E. maddness
      return cachedClearTimeout(marker);
    } catch (e) {
      try {
        // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
        return cachedClearTimeout.call(null, marker);
      } catch (e) {
        // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
        // Some versions of I.E. have different rules for clearTimeout vs setTimeout
        return cachedClearTimeout.call(this, marker);
      }
    }
  }
  var queue = [];
  var draining = false;
  var currentQueue;
  var queueIndex = -1;
  function cleanUpNextTick() {
    if (!draining || !currentQueue) {
      return;
    }
    draining = false;
    if (currentQueue.length) {
      queue = currentQueue.concat(queue);
    } else {
      queueIndex = -1;
    }
    if (queue.length) {
      drainQueue();
    }
  }
  function drainQueue() {
    if (draining) {
      return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;
    var len = queue.length;
    while (len) {
      currentQueue = queue;
      queue = [];
      while (++queueIndex < len) {
        if (currentQueue) {
          currentQueue[queueIndex].run();
        }
      }
      queueIndex = -1;
      len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
  }
  function nextTick(fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
      for (var i = 1; i < arguments.length; i++) {
        args[i - 1] = arguments[i];
      }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
      runTimeout(drainQueue);
    }
  }
  // v8 likes predictible objects
  function Item(fun, array) {
    this.fun = fun;
    this.array = array;
  }
  Item.prototype.run = function () {
    this.fun.apply(null, this.array);
  };
  var title = 'browser';
  var platform = 'browser';
  var browser = true;
  var env = {};
  var argv = [];
  var version = ''; // empty string to avoid regexp issues
  var versions = {};
  var release = {};
  var config = {};
  function noop() {}
  var on = noop;
  var addListener = noop;
  var once = noop;
  var off = noop;
  var removeListener = noop;
  var removeAllListeners = noop;
  var emit = noop;
  function binding(name) {
    throw new Error('process.binding is not supported');
  }
  function cwd() {
    return '/';
  }
  function chdir(dir) {
    throw new Error('process.chdir is not supported');
  }
  function umask() {
    return 0;
  }

  // from https://github.com/kumavis/browser-process-hrtime/blob/master/index.js
  var performance = global$1.performance || {};
  var performanceNow = performance.now || performance.mozNow || performance.msNow || performance.oNow || performance.webkitNow || function () {
    return new Date().getTime();
  };

  // generate timestamp or delta
  // see http://nodejs.org/api/process.html#process_process_hrtime
  function hrtime(previousTimestamp) {
    var clocktime = performanceNow.call(performance) * 1e-3;
    var seconds = Math.floor(clocktime);
    var nanoseconds = Math.floor(clocktime % 1 * 1e9);
    if (previousTimestamp) {
      seconds = seconds - previousTimestamp[0];
      nanoseconds = nanoseconds - previousTimestamp[1];
      if (nanoseconds < 0) {
        seconds--;
        nanoseconds += 1e9;
      }
    }
    return [seconds, nanoseconds];
  }
  var startTime = new Date();
  function uptime() {
    var currentTime = new Date();
    var dif = currentTime - startTime;
    return dif / 1000;
  }
  var browser$1 = {
    nextTick: nextTick,
    title: title,
    browser: browser,
    env: env,
    argv: argv,
    version: version,
    versions: versions,
    on: on,
    addListener: addListener,
    once: once,
    off: off,
    removeListener: removeListener,
    removeAllListeners: removeAllListeners,
    emit: emit,
    binding: binding,
    cwd: cwd,
    chdir: chdir,
    umask: umask,
    hrtime: hrtime,
    platform: platform,
    release: release,
    config: config,
    uptime: uptime
  };
  var process = browser$1;

  const promises = {};

  // Copyright Joyent, Inc. and other Node contributors.
  //
  // Permission is hereby granted, free of charge, to any person obtaining a
  // copy of this software and associated documentation files (the
  // "Software"), to deal in the Software without restriction, including
  // without limitation the rights to use, copy, modify, merge, publish,
  // distribute, sublicense, and/or sell copies of the Software, and to permit
  // persons to whom the Software is furnished to do so, subject to the
  // following conditions:
  //
  // The above copyright notice and this permission notice shall be included
  // in all copies or substantial portions of the Software.
  //
  // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
  // OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
  // NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
  // DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
  // OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
  // USE OR OTHER DEALINGS IN THE SOFTWARE.

  // resolves . and .. elements in a path array with directory names there
  // must be no slashes, empty elements, or device names (c:\) in the array
  // (so also no leading and trailing slashes - it does not distinguish
  // relative and absolute paths)
  function normalizeArray(parts, allowAboveRoot) {
    // if the path tries to go above the root, `up` ends up > 0
    var up = 0;
    for (var i = parts.length - 1; i >= 0; i--) {
      var last = parts[i];
      if (last === '.') {
        parts.splice(i, 1);
      } else if (last === '..') {
        parts.splice(i, 1);
        up++;
      } else if (up) {
        parts.splice(i, 1);
        up--;
      }
    }

    // if the path is allowed to go above the root, restore leading ..s
    if (allowAboveRoot) {
      for (; up--; up) {
        parts.unshift('..');
      }
    }
    return parts;
  }

  // Split a filename into [root, dir, basename, ext], unix version
  // 'root' is just a slash, or nothing.
  var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
  var splitPath = function splitPath(filename) {
    return splitPathRe.exec(filename).slice(1);
  };

  // path.resolve([from ...], to)
  // posix version
  function resolve() {
    var resolvedPath = '',
      resolvedAbsolute = false;
    for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
      var path = i >= 0 ? arguments[i] : '/';

      // Skip empty and invalid entries
      if (typeof path !== 'string') {
        throw new TypeError('Arguments to path.resolve must be strings');
      } else if (!path) {
        continue;
      }
      resolvedPath = path + '/' + resolvedPath;
      resolvedAbsolute = path.charAt(0) === '/';
    }

    // At this point the path should be resolved to a full absolute path, but
    // handle relative paths to be safe (might happen when process.cwd() fails)

    // Normalize the path
    resolvedPath = normalizeArray(filter(resolvedPath.split('/'), function (p) {
      return !!p;
    }), !resolvedAbsolute).join('/');
    return (resolvedAbsolute ? '/' : '') + resolvedPath || '.';
  }

  // path.normalize(path)
  // posix version
  function normalize(path) {
    var isPathAbsolute = isAbsolute(path),
      trailingSlash = substr(path, -1) === '/';

    // Normalize the path
    path = normalizeArray(filter(path.split('/'), function (p) {
      return !!p;
    }), !isPathAbsolute).join('/');
    if (!path && !isPathAbsolute) {
      path = '.';
    }
    if (path && trailingSlash) {
      path += '/';
    }
    return (isPathAbsolute ? '/' : '') + path;
  }

  // posix version
  function isAbsolute(path) {
    return path.charAt(0) === '/';
  }

  // posix version
  function join() {
    var paths = Array.prototype.slice.call(arguments, 0);
    return normalize(filter(paths, function (p, index) {
      if (typeof p !== 'string') {
        throw new TypeError('Arguments to path.join must be strings');
      }
      return p;
    }).join('/'));
  }
  function dirname(path) {
    var result = splitPath(path),
      root = result[0],
      dir = result[1];
    if (!root && !dir) {
      // No dirname whatsoever
      return '.';
    }
    if (dir) {
      // It has a dirname, strip trailing slash
      dir = dir.substr(0, dir.length - 1);
    }
    return root + dir;
  }
  function filter(xs, f) {
    if (xs.filter) return xs.filter(f);
    var res = [];
    for (var i = 0; i < xs.length; i++) {
      if (f(xs[i], i, xs)) res.push(xs[i]);
    }
    return res;
  }

  // String.prototype.substr - negative index don't work in IE8
  var substr = 'ab'.substr(-1) === 'b' ? function (str, start, len) {
    return str.substr(start, len);
  } : function (str, start, len) {
    if (start < 0) start = str.length + start;
    return str.substr(start, len);
  };

  var fetch$1 = fetch;

  var Observable = /*#__PURE__*/function () {
    function Observable() {
      _classCallCheck(this, Observable);
      this.callbacks = {};
    }
    _createClass(Observable, [{
      key: "bind",
      value: function bind(event, callback) {
        var callbacks = this.callbacks[event] || [];
        callbacks.push(callback);
        this.callbacks[event] = callbacks;
        return callback;
      }
    }, {
      key: "unbind",
      value: function unbind(event, callback) {
        var callbacks = this.callbacks[event] || [];
        if (!callback) {
          delete this.callbacks[event];
          return;
        }
        var index = callbacks.indexOf(callback);
        if (index === -1) {
          return;
        }
        callbacks.splice(index, 1);
        this.callbacks[event] = callbacks;
      }
    }, {
      key: "trigger",
      value: function trigger(event) {
        var callbacks = this.callbacks[event] || [];
        var results = [];
        var _iterator = _createForOfIteratorHelper(callbacks),
          _step;
        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var callback = _step.value;
            var result = callback.apply(this, Array.prototype.slice.call(arguments, 1));
            result !== undefined && result !== null && results.push(result);
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
        return Promise.all(results);
      }
    }]);
    return Observable;
  }();
  var _verify = function verify(condition) {
    var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var code = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var exception = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    var kwargs = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
    if (condition) return;
    message = message || "Verification failed";
    var Exception = exception || Error;
    kwargs = Object.assign({}, kwargs);
    if (message !== null && message !== undefined) kwargs.message = message;
    if (code !== null && message !== undefined) kwargs.code = code;
    var throwable = new Exception(kwargs.message || undefined);
    throwable.kwargs = kwargs;
    for (var _i = 0, _Object$entries = Object.entries(kwargs); _i < _Object$entries.length; _i++) {
      var _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2),
        key = _Object$entries$_i[0],
        value = _Object$entries$_i[1];
      if (throwable[key] !== undefined) continue;
      throwable[key] = value;
    }
    throw throwable;
  };
  var HOME_DIR = null;
  var pathExists = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(path) {
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return promises.access(path);
          case 3:
            _context.next = 8;
            break;
          case 5:
            _context.prev = 5;
            _context.t0 = _context["catch"](0);
            return _context.abrupt("return", false);
          case 8:
            return _context.abrupt("return", true);
          case 9:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[0, 5]]);
    }));
    return function pathExists(_x) {
      return _ref.apply(this, arguments);
    };
  }();
  var expandUser = function expandUser(path) {
    if (!path) return path;
    if (path === "~") return _homeDir();
    if (path.slice(0, 2) !== "~/") return path;
    return join(HOME_DIR, path.slice(2));
  };
  var getEnv = function getEnv(name) {
    // eslint-disable-next-line no-undef
    if (typeof Deno !== "undefined") return Deno.env.get(name);
    return env[name];
  };
  var getEnvObject = function getEnvObject() {
    // eslint-disable-next-line no-undef
    if (typeof Deno !== "undefined") return Deno.env.toObject();
    return env;
  };
  var _homeDir = function _homeDir() {
    if (HOME_DIR !== null) return HOME_DIR;
    var isWindows = Boolean(typeof process !== "undefined" && process.platform === "win32");
    HOME_DIR = getEnv(isWindows ? "USERPROFILE" : "HOME") || "/";
    return HOME_DIR;
  };
  var FILE_NAME = "yonius.json";
  var HOME_FILE = "~/.home";
  var IMPORT_NAMES = ["$import", "$include", "$IMPORT", "$INCLUDE"];
  var globals = typeof global$1 === "undefined" ? typeof window === "undefined" ? typeof self === "undefined" ? {} : self : window : global$1;
  globals.CONFIGS = globals.CONFIGS === undefined ? {} : globals.CONFIGS;
  globals.CONFIG_F = globals.CONFIG_F === undefined ? [] : globals.CONFIG_F;
  globals.HOMES = globals.HOMES === undefined ? [] : globals.HOMES;
  globals.LOADED = globals.LOADED === undefined ? false : globals.LOADED;
  var load = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3() {
      var names,
        path,
        encoding,
        force,
        ctx,
        paths,
        homes,
        _iterator2,
        _step2,
        home,
        _iterator3,
        _step3,
        _path,
        _iterator4,
        _step4,
        _name,
        _args3 = arguments;
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            names = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : [FILE_NAME];
            path = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : null;
            encoding = _args3.length > 2 && _args3[2] !== undefined ? _args3[2] : "utf-8";
            force = _args3.length > 3 && _args3[3] !== undefined ? _args3[3] : false;
            ctx = _args3.length > 4 && _args3[4] !== undefined ? _args3[4] : null;
            if (!(globals.LOADED && !force)) {
              _context3.next = 7;
              break;
            }
            return _context3.abrupt("return");
          case 7:
            paths = [];
            _context3.next = 10;
            return getHomes();
          case 10:
            homes = _context3.sent;
            _iterator2 = _createForOfIteratorHelper(homes);
            try {
              for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                home = _step2.value;
                paths = paths.concat([join(home), join(home, ".config")]);
              }
            } catch (err) {
              _iterator2.e(err);
            } finally {
              _iterator2.f();
            }
            if (path) paths.push(path);
            _iterator3 = _createForOfIteratorHelper(paths);
            _context3.prev = 15;
            _iterator3.s();
          case 17:
            if ((_step3 = _iterator3.n()).done) {
              _context3.next = 38;
              break;
            }
            _path = _step3.value;
            _iterator4 = _createForOfIteratorHelper(names);
            _context3.prev = 20;
            _iterator4.s();
          case 22:
            if ((_step4 = _iterator4.n()).done) {
              _context3.next = 28;
              break;
            }
            _name = _step4.value;
            _context3.next = 26;
            return loadFile(_name, _path, encoding, ctx);
          case 26:
            _context3.next = 22;
            break;
          case 28:
            _context3.next = 33;
            break;
          case 30:
            _context3.prev = 30;
            _context3.t0 = _context3["catch"](20);
            _iterator4.e(_context3.t0);
          case 33:
            _context3.prev = 33;
            _iterator4.f();
            return _context3.finish(33);
          case 36:
            _context3.next = 17;
            break;
          case 38:
            _context3.next = 43;
            break;
          case 40:
            _context3.prev = 40;
            _context3.t1 = _context3["catch"](15);
            _iterator3.e(_context3.t1);
          case 43:
            _context3.prev = 43;
            _iterator3.f();
            return _context3.finish(43);
          case 46:
            _context3.next = 48;
            return loadEnv(ctx);
          case 48:
            globals.LOADED = true;
          case 49:
          case "end":
            return _context3.stop();
        }
      }, _callee3, null, [[15, 40, 43, 46], [20, 30, 33, 36]]);
    }));
    return function load() {
      return _ref3.apply(this, arguments);
    };
  }();
  var loadFile = /*#__PURE__*/function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4() {
      var name,
        path,
        encoding,
        ctx,
        configs,
        configF,
        key,
        value,
        exists,
        filePath,
        basePath,
        data,
        dataJ,
        _i2,
        _Object$entries2,
        _Object$entries2$_i,
        _args4 = arguments;
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) switch (_context4.prev = _context4.next) {
          case 0:
            name = _args4.length > 0 && _args4[0] !== undefined ? _args4[0] : FILE_NAME;
            path = _args4.length > 1 && _args4[1] !== undefined ? _args4[1] : null;
            encoding = _args4.length > 2 && _args4[2] !== undefined ? _args4[2] : "utf-8";
            ctx = _args4.length > 3 && _args4[3] !== undefined ? _args4[3] : null;
            configs = ctx ? ctx.configs : globals.CONFIGS;
            configF = ctx ? ctx.configF : globals.CONFIG_F;
            if (path) path = normalize(path);
            if (path) filePath = join(path, name);else filePath = name;
            filePath = resolve(filePath);
            filePath = normalize(filePath);
            basePath = dirname(filePath);
            _context4.next = 13;
            return pathExists(filePath);
          case 13:
            exists = _context4.sent;
            if (exists) {
              _context4.next = 16;
              break;
            }
            return _context4.abrupt("return");
          case 16:
            exists = configF.includes(filePath);
            if (exists) configF.splice(configF.indexOf(filePath), 1);
            configF.push(filePath);
            _context4.next = 21;
            return promises.readFile(filePath, {
              encoding: encoding
            });
          case 21:
            data = _context4.sent;
            dataJ = JSON.parse(data);
            _context4.next = 25;
            return _loadIncludes(basePath, dataJ, encoding);
          case 25:
            _i2 = 0, _Object$entries2 = Object.entries(dataJ);
          case 26:
            if (!(_i2 < _Object$entries2.length)) {
              _context4.next = 36;
              break;
            }
            _Object$entries2$_i = _slicedToArray(_Object$entries2[_i2], 2);
            key = _Object$entries2$_i[0];
            value = _Object$entries2$_i[1];
            if (_isValid(key)) {
              _context4.next = 32;
              break;
            }
            return _context4.abrupt("continue", 33);
          case 32:
            configs[key] = value;
          case 33:
            _i2++;
            _context4.next = 26;
            break;
          case 36:
          case "end":
            return _context4.stop();
        }
      }, _callee4);
    }));
    return function loadFile() {
      return _ref4.apply(this, arguments);
    };
  }();
  var loadEnv = /*#__PURE__*/function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5() {
      var ctx,
        env,
        configs,
        _args5 = arguments;
      return _regeneratorRuntime().wrap(function _callee5$(_context5) {
        while (1) switch (_context5.prev = _context5.next) {
          case 0:
            ctx = _args5.length > 0 && _args5[0] !== undefined ? _args5[0] : null;
            env = getEnvObject();
            configs = ctx ? ctx.configs : globals.CONFIGS;
            if (!(env === undefined || env === null)) {
              _context5.next = 5;
              break;
            }
            return _context5.abrupt("return");
          case 5:
            Object.entries(env).forEach(function (_ref6) {
              var _ref7 = _slicedToArray(_ref6, 2),
                key = _ref7[0],
                value = _ref7[1];
              configs[key] = value;
            });
          case 6:
          case "end":
            return _context5.stop();
        }
      }, _callee5);
    }));
    return function loadEnv() {
      return _ref5.apply(this, arguments);
    };
  }();
  var getHomes = /*#__PURE__*/function () {
    var _ref8 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6() {
      var filePath,
        fallback,
        encoding,
        forceDefault,
        env,
        exists,
        data,
        paths,
        _iterator5,
        _step5,
        path,
        _args6 = arguments;
      return _regeneratorRuntime().wrap(function _callee6$(_context6) {
        while (1) switch (_context6.prev = _context6.next) {
          case 0:
            filePath = _args6.length > 0 && _args6[0] !== undefined ? _args6[0] : HOME_FILE;
            fallback = _args6.length > 1 && _args6[1] !== undefined ? _args6[1] : "~";
            encoding = _args6.length > 2 && _args6[2] !== undefined ? _args6[2] : "utf-8";
            forceDefault = _args6.length > 3 && _args6[3] !== undefined ? _args6[3] : false;
            if (!(globals.HOMES.length > 0)) {
              _context6.next = 6;
              break;
            }
            return _context6.abrupt("return", globals.HOMES);
          case 6:
            env = getEnvObject();
            globals.HOMES = env.HOMES === undefined ? null : env.HOMES;
            globals.HOMES = globals.HOMES ? globals.HOMES.split(";") : globals.HOMES;
            if (!(globals.HOMES !== null)) {
              _context6.next = 11;
              break;
            }
            return _context6.abrupt("return", globals.HOMES);
          case 11:
            fallback = expandUser(fallback);
            fallback = normalize(fallback);
            globals.HOMES = [fallback];
            filePath = expandUser(filePath);
            filePath = normalize(filePath);
            _context6.next = 18;
            return pathExists(filePath);
          case 18:
            exists = _context6.sent;
            if (exists) {
              _context6.next = 21;
              break;
            }
            return _context6.abrupt("return", globals.HOMES);
          case 21:
            if (!forceDefault) globals.HOMES.splice(0, globals.HOMES.length);
            _context6.next = 24;
            return promises.readFile(filePath, {
              encoding: encoding
            });
          case 24:
            data = _context6.sent;
            data = data.trim();
            paths = data.split(/\r?\n/);
            paths = paths.map(function (v) {
              return v.trim();
            });
            _iterator5 = _createForOfIteratorHelper(paths);
            _context6.prev = 29;
            _iterator5.s();
          case 31:
            if ((_step5 = _iterator5.n()).done) {
              _context6.next = 41;
              break;
            }
            path = _step5.value;
            path = path.trim();
            if (path) {
              _context6.next = 36;
              break;
            }
            return _context6.abrupt("continue", 39);
          case 36:
            path = expandUser(path);
            path = normalize(path);
            globals.HOMES.push(path);
          case 39:
            _context6.next = 31;
            break;
          case 41:
            _context6.next = 46;
            break;
          case 43:
            _context6.prev = 43;
            _context6.t0 = _context6["catch"](29);
            _iterator5.e(_context6.t0);
          case 46:
            _context6.prev = 46;
            _iterator5.f();
            return _context6.finish(46);
          case 49:
            return _context6.abrupt("return", globals.HOMES);
          case 50:
          case "end":
            return _context6.stop();
        }
      }, _callee6, null, [[29, 43, 46, 49]]);
    }));
    return function getHomes() {
      return _ref8.apply(this, arguments);
    };
  }();
  var _loadIncludes = /*#__PURE__*/function () {
    var _ref9 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee7(basePath, config) {
      var encoding,
        includes,
        _i3,
        _IMPORT_NAMES,
        alias,
        _iterator6,
        _step6,
        include,
        _args7 = arguments;
      return _regeneratorRuntime().wrap(function _callee7$(_context7) {
        while (1) switch (_context7.prev = _context7.next) {
          case 0:
            encoding = _args7.length > 2 && _args7[2] !== undefined ? _args7[2] : "utf-8";
            includes = [];
            for (_i3 = 0, _IMPORT_NAMES = IMPORT_NAMES; _i3 < _IMPORT_NAMES.length; _i3++) {
              alias = _IMPORT_NAMES[_i3];
              includes = config[alias] === undefined ? includes : config[alias];
            }
            if (typeof includes === "string") {
              includes = includes.split(";");
            }
            _iterator6 = _createForOfIteratorHelper(includes);
            _context7.prev = 5;
            _iterator6.s();
          case 7:
            if ((_step6 = _iterator6.n()).done) {
              _context7.next = 13;
              break;
            }
            include = _step6.value;
            _context7.next = 11;
            return loadFile(include, basePath, encoding);
          case 11:
            _context7.next = 7;
            break;
          case 13:
            _context7.next = 18;
            break;
          case 15:
            _context7.prev = 15;
            _context7.t0 = _context7["catch"](5);
            _iterator6.e(_context7.t0);
          case 18:
            _context7.prev = 18;
            _iterator6.f();
            return _context7.finish(18);
          case 21:
          case "end":
            return _context7.stop();
        }
      }, _callee7, null, [[5, 15, 18, 21]]);
    }));
    return function _loadIncludes(_x3, _x4) {
      return _ref9.apply(this, arguments);
    };
  }();
  var _isValid = function _isValid(key) {
    if (IMPORT_NAMES.includes(key)) return false;
    return true;
  };
  var MixinBuilder = /*#__PURE__*/function () {
    function MixinBuilder(superclass) {
      _classCallCheck(this, MixinBuilder);
      this.superclass = superclass;
    }
    _createClass(MixinBuilder, [{
      key: "with",
      value: function _with() {
        for (var _len = arguments.length, mixins = new Array(_len), _key = 0; _key < _len; _key++) {
          mixins[_key] = arguments[_key];
        }
        return mixins.reduce(function (c, mixin) {
          return mixin(c);
        }, this.superclass);
      }
    }]);
    return MixinBuilder;
  }();
  var mix = function mix(superclass) {
    return new MixinBuilder(superclass);
  };

  /**
   * Encodes the multiple values as and encoded URI component, the
   * values can be wither defined as an array (order is preserved)
   * or as an object (where sequence order is not preserved).
   *
   * The value of each item can be either a primitive type or a sequence
   * in case it's of sequence the values are going to be encoded as
   * multiple parameters separated by the '&' character.
   *
   * @param {(Array|Object[])} values The values to be encoded as an
   * URI component (like GET params).
   * @returns {String} A string with the query encoded values.
   */
  var urlEncode = function urlEncode(values) {
    // constructs the parts array that is going to
    // store the multiple and values
    var parts = [];

    // in case the provided value is not an array
    // then assumes it's an object and retrieve entries
    if (!Array.isArray(values)) {
      values = Object.entries(values);
    }

    // iterates over the complete set of pairs available
    // from the key value pairs to be able to encode them
    // properly, notice that the values themselves can be
    // sequences allowing multiple repetition of key
    values.forEach(function (_ref23) {
      var _ref24 = _slicedToArray(_ref23, 2),
        key = _ref24[0],
        value = _ref24[1];
      if (!Array.isArray(value)) {
        value = [value];
      }
      var keyEncoded = encodeURIComponent(key);
      value.forEach(function (_value) {
        if (_value === undefined || _value === null) {
          return;
        }
        var valueEncoded = encodeURIComponent(_value);
        parts.push("".concat(keyEncoded, "=").concat(valueEncoded));
      });
    });

    // joins the complete set of parts with the and
    // separator and then returns the final string value
    return parts.join("&");
  };
  var AUTH_ERRORS = [401, 403, 440, 499];
  var API$1 = /*#__PURE__*/function (_Observable) {
    _inherits(API, _Observable);
    var _super = _createSuper(API);
    function API() {
      var _this;
      var kwargs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      _classCallCheck(this, API);
      _this = _super.call(this);
      _this.kwargs = kwargs;
      return _this;
    }
    _createClass(API, [{
      key: "build",
      value: function () {
        var _build = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee9(method, url) {
          return _regeneratorRuntime().wrap(function _callee9$(_context9) {
            while (1) switch (_context9.prev = _context9.next) {
              case 0:
              case 1:
              case "end":
                return _context9.stop();
            }
          }, _callee9);
        }));
        function build(_x7, _x8) {
          return _build.apply(this, arguments);
        }
        return build;
      }()
    }, {
      key: "authCallback",
      value: function () {
        var _authCallback = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee10(params, headers) {
          return _regeneratorRuntime().wrap(function _callee10$(_context10) {
            while (1) switch (_context10.prev = _context10.next) {
              case 0:
              case "end":
                return _context10.stop();
            }
          }, _callee10);
        }));
        function authCallback(_x9, _x10) {
          return _authCallback.apply(this, arguments);
        }
        return authCallback;
      }()
    }, {
      key: "get",
      value: function () {
        var _get = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee11(url) {
          var options,
            result,
            _args11 = arguments;
          return _regeneratorRuntime().wrap(function _callee11$(_context11) {
            while (1) switch (_context11.prev = _context11.next) {
              case 0:
                options = _args11.length > 1 && _args11[1] !== undefined ? _args11[1] : {};
                _context11.next = 3;
                return this.methodBasic("GET", url, options);
              case 3:
                result = _context11.sent;
                return _context11.abrupt("return", result);
              case 5:
              case "end":
                return _context11.stop();
            }
          }, _callee11, this);
        }));
        function get(_x11) {
          return _get.apply(this, arguments);
        }
        return get;
      }()
    }, {
      key: "post",
      value: function () {
        var _post = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee12(url) {
          var options,
            result,
            _args12 = arguments;
          return _regeneratorRuntime().wrap(function _callee12$(_context12) {
            while (1) switch (_context12.prev = _context12.next) {
              case 0:
                options = _args12.length > 1 && _args12[1] !== undefined ? _args12[1] : {};
                _context12.next = 3;
                return this.methodPayload("POST", url, options);
              case 3:
                result = _context12.sent;
                return _context12.abrupt("return", result);
              case 5:
              case "end":
                return _context12.stop();
            }
          }, _callee12, this);
        }));
        function post(_x12) {
          return _post.apply(this, arguments);
        }
        return post;
      }()
    }, {
      key: "put",
      value: function () {
        var _put = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee13(url) {
          var options,
            result,
            _args13 = arguments;
          return _regeneratorRuntime().wrap(function _callee13$(_context13) {
            while (1) switch (_context13.prev = _context13.next) {
              case 0:
                options = _args13.length > 1 && _args13[1] !== undefined ? _args13[1] : {};
                _context13.next = 3;
                return this.methodPayload("PUT", url, options);
              case 3:
                result = _context13.sent;
                return _context13.abrupt("return", result);
              case 5:
              case "end":
                return _context13.stop();
            }
          }, _callee13, this);
        }));
        function put(_x13) {
          return _put.apply(this, arguments);
        }
        return put;
      }()
    }, {
      key: "delete",
      value: function () {
        var _delete2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee14(url) {
          var options,
            result,
            _args14 = arguments;
          return _regeneratorRuntime().wrap(function _callee14$(_context14) {
            while (1) switch (_context14.prev = _context14.next) {
              case 0:
                options = _args14.length > 1 && _args14[1] !== undefined ? _args14[1] : {};
                _context14.next = 3;
                return this.methodBasic("DELETE", url, options);
              case 3:
                result = _context14.sent;
                return _context14.abrupt("return", result);
              case 5:
              case "end":
                return _context14.stop();
            }
          }, _callee14, this);
        }));
        function _delete(_x14) {
          return _delete2.apply(this, arguments);
        }
        return _delete;
      }()
    }, {
      key: "patch",
      value: function () {
        var _patch = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee15(url) {
          var options,
            result,
            _args15 = arguments;
          return _regeneratorRuntime().wrap(function _callee15$(_context15) {
            while (1) switch (_context15.prev = _context15.next) {
              case 0:
                options = _args15.length > 1 && _args15[1] !== undefined ? _args15[1] : {};
                _context15.next = 3;
                return this.methodPayload("PATCH", url, options);
              case 3:
                result = _context15.sent;
                return _context15.abrupt("return", result);
              case 5:
              case "end":
                return _context15.stop();
            }
          }, _callee15, this);
        }));
        function patch(_x15) {
          return _patch.apply(this, arguments);
        }
        return patch;
      }()
    }, {
      key: "options",
      value: function () {
        var _options2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee16(url) {
          var _options,
            result,
            _args16 = arguments;
          return _regeneratorRuntime().wrap(function _callee16$(_context16) {
            while (1) switch (_context16.prev = _context16.next) {
              case 0:
                _options = _args16.length > 1 && _args16[1] !== undefined ? _args16[1] : {};
                _context16.next = 3;
                return this.methodBasic("OPTIONS", url, _options);
              case 3:
                result = _context16.sent;
                return _context16.abrupt("return", result);
              case 5:
              case "end":
                return _context16.stop();
            }
          }, _callee16, this);
        }));
        function options(_x16) {
          return _options2.apply(this, arguments);
        }
        return options;
      }()
    }, {
      key: "methodBasic",
      value: function () {
        var _methodBasic2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee17(method, url) {
          var options,
            _args17 = arguments;
          return _regeneratorRuntime().wrap(function _callee17$(_context17) {
            while (1) switch (_context17.prev = _context17.next) {
              case 0:
                options = _args17.length > 2 && _args17[2] !== undefined ? _args17[2] : {};
                options.params = options.params !== undefined ? options.params : {};
                options.headers = options.headers !== undefined ? options.headers : {};
                _context17.prev = 3;
                _context17.next = 6;
                return this._methodBasic(method, url, options);
              case 6:
                return _context17.abrupt("return", _context17.sent);
              case 9:
                _context17.prev = 9;
                _context17.t0 = _context17["catch"](3);
                if (!AUTH_ERRORS.includes(_context17.t0.code)) {
                  _context17.next = 19;
                  break;
                }
                _context17.next = 14;
                return this.authCallback(options.params, options.headers);
              case 14:
                _context17.next = 16;
                return this._methodBasic(method, url, options);
              case 16:
                return _context17.abrupt("return", _context17.sent);
              case 19:
                throw _context17.t0;
              case 20:
              case "end":
                return _context17.stop();
            }
          }, _callee17, this, [[3, 9]]);
        }));
        function methodBasic(_x17, _x18) {
          return _methodBasic2.apply(this, arguments);
        }
        return methodBasic;
      }()
    }, {
      key: "methodPayload",
      value: function () {
        var _methodPayload2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee18(method, url) {
          var options,
            _args18 = arguments;
          return _regeneratorRuntime().wrap(function _callee18$(_context18) {
            while (1) switch (_context18.prev = _context18.next) {
              case 0:
                options = _args18.length > 2 && _args18[2] !== undefined ? _args18[2] : {};
                options.params = options.params !== undefined ? options.params : {};
                options.headers = options.headers !== undefined ? options.headers : {};
                _context18.prev = 3;
                _context18.next = 6;
                return this._methodPayload(method, url, options);
              case 6:
                return _context18.abrupt("return", _context18.sent);
              case 9:
                _context18.prev = 9;
                _context18.t0 = _context18["catch"](3);
                if (!AUTH_ERRORS.includes(_context18.t0.code)) {
                  _context18.next = 19;
                  break;
                }
                _context18.next = 14;
                return this.authCallback(options.params, options.headers);
              case 14:
                _context18.next = 16;
                return this._methodPayload(method, url, options);
              case 16:
                return _context18.abrupt("return", _context18.sent);
              case 19:
                throw _context18.t0;
              case 20:
              case "end":
                return _context18.stop();
            }
          }, _callee18, this, [[3, 9]]);
        }));
        function methodPayload(_x19, _x20) {
          return _methodPayload2.apply(this, arguments);
        }
        return methodPayload;
      }()
    }, {
      key: "_methodBasic",
      value: function () {
        var _methodBasic3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee19(method, url) {
          var options,
            params,
            headers,
            kwargs,
            handle,
            query,
            response,
            result,
            _args19 = arguments;
          return _regeneratorRuntime().wrap(function _callee19$(_context19) {
            while (1) switch (_context19.prev = _context19.next) {
              case 0:
                options = _args19.length > 2 && _args19[2] !== undefined ? _args19[2] : {};
                params = options.params !== undefined ? options.params : {};
                headers = options.headers !== undefined ? options.headers : {};
                kwargs = options.kwargs !== undefined ? options.kwargs : {};
                handle = options.handle !== undefined ? options.handle : true;
                _context19.next = 7;
                return this.build(method, url, {
                  params: params,
                  headers: headers,
                  kwargs: kwargs
                });
              case 7:
                query = urlEncode(params || {});
                if (query) url += url.includes("?") ? "&" + query : "?" + query;
                _context19.next = 11;
                return fetch$1(url, {
                  method: method,
                  headers: headers || {}
                });
              case 11:
                response = _context19.sent;
                if (!handle) {
                  _context19.next = 18;
                  break;
                }
                _context19.next = 15;
                return this._handleResponse(response);
              case 15:
                _context19.t0 = _context19.sent;
                _context19.next = 19;
                break;
              case 18:
                _context19.t0 = response;
              case 19:
                result = _context19.t0;
                return _context19.abrupt("return", result);
              case 21:
              case "end":
                return _context19.stop();
            }
          }, _callee19, this);
        }));
        function _methodBasic(_x21, _x22) {
          return _methodBasic3.apply(this, arguments);
        }
        return _methodBasic;
      }()
    }, {
      key: "_methodPayload",
      value: function () {
        var _methodPayload3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee20(method, url) {
          var options,
            params,
            headers,
            data,
            dataJ,
            dataM,
            mime,
            kwargs,
            handle,
            query,
            response,
            result,
            _args20 = arguments;
          return _regeneratorRuntime().wrap(function _callee20$(_context20) {
            while (1) switch (_context20.prev = _context20.next) {
              case 0:
                options = _args20.length > 2 && _args20[2] !== undefined ? _args20[2] : {};
                params = options.params !== undefined ? options.params : {};
                headers = options.headers !== undefined ? options.headers : {};
                data = options.data !== undefined ? options.data : null;
                dataJ = options.dataJ !== undefined ? options.dataJ : null;
                dataM = options.dataM !== undefined ? options.dataM : null;
                mime = options.mime !== undefined ? options.mime : null;
                kwargs = options.kwargs !== undefined ? options.kwargs : {};
                handle = options.handle !== undefined ? options.handle : true;
                _context20.next = 11;
                return this.build(method, url, {
                  params: params,
                  headers: headers,
                  data: data,
                  dataJ: dataJ,
                  dataM: dataM,
                  mime: mime,
                  kwargs: kwargs
                });
              case 11:
                query = urlEncode(params || {});
                if (data !== null) {
                  if (query) url += url.includes("?") ? "&" + query : "?" + query;
                } else if (dataJ !== null) {
                  data = JSON.stringify(dataJ);
                  if (query) url += url.includes("?") ? "&" + query : "?" + query;
                  mime = mime || "application/json";
                } else if (dataM !== null) {
                  if (query) url += url.includes("?") ? "&" + query : "?" + query;
                } else if (query) {
                  data = query;
                  mime = mime || "application/x-www-form-urlencoded";
                }
                headers = Object.assign({}, headers);
                if (mime) headers["Content-Type"] = mime;
                _context20.next = 17;
                return fetch$1(url, {
                  method: method,
                  headers: headers || {},
                  body: data
                });
              case 17:
                response = _context20.sent;
                if (!handle) {
                  _context20.next = 24;
                  break;
                }
                _context20.next = 21;
                return this._handleResponse(response);
              case 21:
                _context20.t0 = _context20.sent;
                _context20.next = 25;
                break;
              case 24:
                _context20.t0 = response;
              case 25:
                result = _context20.t0;
                return _context20.abrupt("return", result);
              case 27:
              case "end":
                return _context20.stop();
            }
          }, _callee20, this);
        }));
        function _methodPayload(_x23, _x24) {
          return _methodPayload3.apply(this, arguments);
        }
        return _methodPayload;
      }()
    }, {
      key: "_handleResponse",
      value: function () {
        var _handleResponse2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee21(response) {
          var errorMessage,
            result,
            _args21 = arguments;
          return _regeneratorRuntime().wrap(function _callee21$(_context21) {
            while (1) switch (_context21.prev = _context21.next) {
              case 0:
                errorMessage = _args21.length > 1 && _args21[1] !== undefined ? _args21[1] : "Problem in request";
                result = null;
                if (!response.headers.get("content-type").toLowerCase().startsWith("application/json")) {
                  _context21.next = 8;
                  break;
                }
                _context21.next = 5;
                return response.json();
              case 5:
                result = _context21.sent;
                _context21.next = 11;
                break;
              case 8:
                _context21.next = 10;
                return response.blob();
              case 10:
                result = _context21.sent;
              case 11:
                _verify(response.ok, result.error || errorMessage, response.status || 500);
                return _context21.abrupt("return", result);
              case 13:
              case "end":
                return _context21.stop();
            }
          }, _callee21);
        }));
        function _handleResponse(_x25) {
          return _handleResponse2.apply(this, arguments);
        }
        return _handleResponse;
      }()
    }]);
    return API;
  }(Observable);
  var load$1 = /*#__PURE__*/function () {
    var _ref26 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee24() {
      return _regeneratorRuntime().wrap(function _callee24$(_context24) {
        while (1) switch (_context24.prev = _context24.next) {
          case 0:
            _context24.next = 2;
            return load();
          case 2:
          case "end":
            return _context24.stop();
        }
      }, _callee24);
    }));
    return function load$1() {
      return _ref26.apply(this, arguments);
    };
  }();

  var currenciesAPI = function currenciesAPI(superclass) {
    return /*#__PURE__*/function (_superclass) {
      _inherits(_class, _superclass);
      var _super = _createSuper(_class);
      function _class() {
        _classCallCheck(this, _class);
        return _super.apply(this, arguments);
      }
      _createClass(_class, [{
        key: "getCurrencies",
        value: function () {
          var _getCurrencies = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
            var url, response;
            return _regeneratorRuntime().wrap(function _callee$(_context) {
              while (1) switch (_context.prev = _context.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/currencies");
                  _context.next = 3;
                  return this.get(url);
                case 3:
                  response = _context.sent;
                  return _context.abrupt("return", response);
                case 5:
                case "end":
                  return _context.stop();
              }
            }, _callee, this);
          }));
          function getCurrencies() {
            return _getCurrencies.apply(this, arguments);
          }
          return getCurrencies;
        }()
      }]);
      return _class;
    }(superclass);
  };

  var CurrentCommissionAPI = function CurrentCommissionAPI(superclass) {
    return /*#__PURE__*/function (_superclass) {
      _inherits(_class, _superclass);
      var _super = _createSuper(_class);
      function _class() {
        _classCallCheck(this, _class);
        return _super.apply(this, arguments);
      }
      _createClass(_class, [{
        key: "getCurrentCommission",
        value: function () {
          var _getCurrentCommission = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
            var url, response;
            return _regeneratorRuntime().wrap(function _callee$(_context) {
              while (1) switch (_context.prev = _context.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/current-commission");
                  _context.next = 3;
                  return this.get(url);
                case 3:
                  response = _context.sent;
                  return _context.abrupt("return", response);
                case 5:
                case "end":
                  return _context.stop();
              }
            }, _callee, this);
          }));
          function getCurrentCommission() {
            return _getCurrentCommission.apply(this, arguments);
          }
          return getCurrentCommission;
        }()
      }]);
      return _class;
    }(superclass);
  };

  var fxRatesAPI = function fxRatesAPI(superclass) {
    return /*#__PURE__*/function (_superclass) {
      _inherits(_class, _superclass);
      var _super = _createSuper(_class);
      function _class() {
        _classCallCheck(this, _class);
        return _super.apply(this, arguments);
      }
      _createClass(_class, [{
        key: "getFxRates",
        value: function () {
          var _getFxRates = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
            var url, response;
            return _regeneratorRuntime().wrap(function _callee$(_context) {
              while (1) switch (_context.prev = _context.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/fx-rates");
                  _context.next = 3;
                  return this.get(url);
                case 3:
                  response = _context.sent;
                  return _context.abrupt("return", response);
                case 5:
                case "end":
                  return _context.stop();
              }
            }, _callee, this);
          }));
          function getFxRates() {
            return _getFxRates.apply(this, arguments);
          }
          return getFxRates;
        }()
      }, {
        key: "getFxRate",
        value: function () {
          var _getFxRate = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(originalCurrency, finalCurrency) {
            var url, options, response;
            return _regeneratorRuntime().wrap(function _callee2$(_context2) {
              while (1) switch (_context2.prev = _context2.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/fx-rate");
                  options = {
                    params: {
                      originalCurrency: originalCurrency,
                      finalCurrency: finalCurrency
                    }
                  };
                  _context2.next = 4;
                  return this.post(url, options);
                case 4:
                  response = _context2.sent;
                  return _context2.abrupt("return", response);
                case 6:
                case "end":
                  return _context2.stop();
              }
            }, _callee2, this);
          }));
          function getFxRate(_x, _x2) {
            return _getFxRate.apply(this, arguments);
          }
          return getFxRate;
        }()
      }]);
      return _class;
    }(superclass);
  };

  var PaymentAPI = function PaymentAPI(superclass) {
    return /*#__PURE__*/function (_superclass) {
      _inherits(_class, _superclass);
      var _super = _createSuper(_class);
      function _class() {
        _classCallCheck(this, _class);
        return _super.apply(this, arguments);
      }
      _createClass(_class, [{
        key: "mbway",
        value: function () {
          var _mbway = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(amount, documentID, email, phoneNumber) {
            var url, options, response;
            return _regeneratorRuntime().wrap(function _callee$(_context) {
              while (1) switch (_context.prev = _context.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/payment/mbway");
                  options = {
                    params: {
                      amount: amount,
                      documentID: documentID,
                      email: email,
                      phoneNumber: phoneNumber
                    }
                  };
                  _context.next = 4;
                  return this.post(url, options);
                case 4:
                  response = _context.sent;
                  return _context.abrupt("return", response);
                case 6:
                case "end":
                  return _context.stop();
              }
            }, _callee, this);
          }));
          function mbway(_x, _x2, _x3, _x4) {
            return _mbway.apply(this, arguments);
          }
          return mbway;
        }()
      }, {
        key: "mbwayStatus",
        value: function () {
          var _mbwayStatus = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(idPayment) {
            var url, options, response;
            return _regeneratorRuntime().wrap(function _callee2$(_context2) {
              while (1) switch (_context2.prev = _context2.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/payment/mbway/status");
                  options = {
                    params: {
                      mbway_id: idPayment
                    }
                  };
                  _context2.next = 4;
                  return this.post(url, options);
                case 4:
                  response = _context2.sent;
                  return _context2.abrupt("return", response);
                case 6:
                case "end":
                  return _context2.stop();
              }
            }, _callee2, this);
          }));
          function mbwayStatus(_x5) {
            return _mbwayStatus.apply(this, arguments);
          }
          return mbwayStatus;
        }()
      }, {
        key: "mcx",
        value: function () {
          var _mcx = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(amount, documentID, phoneNumber) {
            var url, options, response;
            return _regeneratorRuntime().wrap(function _callee3$(_context3) {
              while (1) switch (_context3.prev = _context3.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/payment/mcx");
                  options = {
                    params: {
                      amount: amount,
                      documentID: documentID,
                      phoneNumber: phoneNumber
                    }
                  };
                  _context3.next = 4;
                  return this.post(url, options);
                case 4:
                  response = _context3.sent;
                  return _context3.abrupt("return", response);
                case 6:
                case "end":
                  return _context3.stop();
              }
            }, _callee3, this);
          }));
          function mcx(_x6, _x7, _x8) {
            return _mcx.apply(this, arguments);
          }
          return mcx;
        }()
      }]);
      return _class;
    }(superclass);
  };

  var TransactionsAPI = function TransactionsAPI(superclass) {
    return /*#__PURE__*/function (_superclass) {
      _inherits(_class, _superclass);
      var _super = _createSuper(_class);
      function _class() {
        _classCallCheck(this, _class);
        return _super.apply(this, arguments);
      }
      _createClass(_class, [{
        key: "getFXConfig",
        value: function () {
          var _getFXConfig = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(originalCurrency, finalCurrency, amount) {
            var url, options, response;
            return _regeneratorRuntime().wrap(function _callee$(_context) {
              while (1) switch (_context.prev = _context.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/transactions/sepa/config");
                  options = {
                    params: {
                      originalCurrency: originalCurrency,
                      finalCurrency: finalCurrency,
                      amount: amount
                    }
                  };
                  _context.next = 4;
                  return this.post(url, options);
                case 4:
                  response = _context.sent;
                  return _context.abrupt("return", response);
                case 6:
                case "end":
                  return _context.stop();
              }
            }, _callee, this);
          }));
          function getFXConfig(_x, _x2, _x3) {
            return _getFXConfig.apply(this, arguments);
          }
          return getFXConfig;
        }()
      }, {
        key: "transferCrossCurrency",
        value: function () {
          var _transferCrossCurrency = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
            var _ref,
              sepaBeneficiaryIban,
              sepaBeneficiaryName,
              sepaBeneficiarySwift,
              originalAmount,
              originalCurrency,
              finalAmount,
              finalCurrency,
              fxRate,
              commission,
              url,
              options,
              response,
              _args2 = arguments;
            return _regeneratorRuntime().wrap(function _callee2$(_context2) {
              while (1) switch (_context2.prev = _context2.next) {
                case 0:
                  _ref = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : {}, sepaBeneficiaryIban = _ref.sepaBeneficiaryIban, sepaBeneficiaryName = _ref.sepaBeneficiaryName, sepaBeneficiarySwift = _ref.sepaBeneficiarySwift, originalAmount = _ref.originalAmount, originalCurrency = _ref.originalCurrency, finalAmount = _ref.finalAmount, finalCurrency = _ref.finalCurrency, fxRate = _ref.fxRate, commission = _ref.commission;
                  url = "".concat(this.baseUrl, "/users/send/cross-currency");
                  options = {
                    params: {
                      sepaBeneficiaryIban: sepaBeneficiaryIban,
                      sepaBeneficiaryName: sepaBeneficiaryName,
                      sepaBeneficiarySwift: sepaBeneficiarySwift,
                      originalAmount: originalAmount,
                      originalCurrency: originalCurrency,
                      finalAmount: finalAmount,
                      finalCurrency: finalCurrency,
                      fxRate: fxRate,
                      commission: commission
                    }
                  };
                  _context2.next = 5;
                  return this.post(url, options);
                case 5:
                  response = _context2.sent;
                  return _context2.abrupt("return", response);
                case 7:
                case "end":
                  return _context2.stop();
              }
            }, _callee2, this);
          }));
          function transferCrossCurrency() {
            return _transferCrossCurrency.apply(this, arguments);
          }
          return transferCrossCurrency;
        }()
      }]);
      return _class;
    }(superclass);
  };

  var UsersAPI = function UsersAPI(superclass) {
    return /*#__PURE__*/function (_superclass) {
      _inherits(_class, _superclass);
      var _super = _createSuper(_class);
      function _class() {
        _classCallCheck(this, _class);
        return _super.apply(this, arguments);
      }
      _createClass(_class, [{
        key: "createUser",
        value: function () {
          var _createUser = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(user, deviceFingerprint) {
            var url, options, response;
            return _regeneratorRuntime().wrap(function _callee$(_context) {
              while (1) switch (_context.prev = _context.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/users");
                  options = {
                    params: user,
                    deviceFingerprint: deviceFingerprint
                  };
                  _context.next = 4;
                  return this.post(url, options);
                case 4:
                  response = _context.sent;
                  return _context.abrupt("return", response);
                case 6:
                case "end":
                  return _context.stop();
              }
            }, _callee, this);
          }));
          function createUser(_x, _x2) {
            return _createUser.apply(this, arguments);
          }
          return createUser;
        }()
      }, {
        key: "getMyAccounts",
        value: function () {
          var _getMyAccounts = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
            var url, response;
            return _regeneratorRuntime().wrap(function _callee2$(_context2) {
              while (1) switch (_context2.prev = _context2.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/users/me/accounts");
                  _context2.next = 3;
                  return this.get(url);
                case 3:
                  response = _context2.sent;
                  return _context2.abrupt("return", response);
                case 5:
                case "end":
                  return _context2.stop();
              }
            }, _callee2, this);
          }));
          function getMyAccounts() {
            return _getMyAccounts.apply(this, arguments);
          }
          return getMyAccounts;
        }()
      }, {
        key: "getMyTransactions",
        value: function () {
          var _getMyTransactions = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3() {
            var url, response;
            return _regeneratorRuntime().wrap(function _callee3$(_context3) {
              while (1) switch (_context3.prev = _context3.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/users/me/transactions");
                  _context3.next = 3;
                  return this.get(url);
                case 3:
                  response = _context3.sent;
                  return _context3.abrupt("return", response);
                case 5:
                case "end":
                  return _context3.stop();
              }
            }, _callee3, this);
          }));
          function getMyTransactions() {
            return _getMyTransactions.apply(this, arguments);
          }
          return getMyTransactions;
        }()
      }, {
        key: "setAvatar",
        value: function () {
          var _setAvatar = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4(avatarUrl) {
            var url, options, response;
            return _regeneratorRuntime().wrap(function _callee4$(_context4) {
              while (1) switch (_context4.prev = _context4.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/users/avatar");
                  options = {
                    params: {
                      avatarUrl: avatarUrl
                    }
                  };
                  _context4.next = 4;
                  return this.post(url, options);
                case 4:
                  response = _context4.sent;
                  return _context4.abrupt("return", response);
                case 6:
                case "end":
                  return _context4.stop();
              }
            }, _callee4, this);
          }));
          function setAvatar(_x3) {
            return _setAvatar.apply(this, arguments);
          }
          return setAvatar;
        }()
      }, {
        key: "getAvatar",
        value: function () {
          var _getAvatar = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5() {
            var url, response;
            return _regeneratorRuntime().wrap(function _callee5$(_context5) {
              while (1) switch (_context5.prev = _context5.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/users/me/avatar");
                  _context5.next = 3;
                  return this.get(url);
                case 3:
                  response = _context5.sent;
                  return _context5.abrupt("return", response);
                case 5:
                case "end":
                  return _context5.stop();
              }
            }, _callee5, this);
          }));
          function getAvatar() {
            return _getAvatar.apply(this, arguments);
          }
          return getAvatar;
        }()
      }, {
        key: "getAllUsers",
        value: function () {
          var _getAllUsers = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6() {
            var url, response;
            return _regeneratorRuntime().wrap(function _callee6$(_context6) {
              while (1) switch (_context6.prev = _context6.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/users");
                  _context6.next = 3;
                  return this.get(url);
                case 3:
                  response = _context6.sent;
                  return _context6.abrupt("return", response);
                case 5:
                case "end":
                  return _context6.stop();
              }
            }, _callee6, this);
          }));
          function getAllUsers() {
            return _getAllUsers.apply(this, arguments);
          }
          return getAllUsers;
        }()
      }, {
        key: "searchUser",
        value: function () {
          var _searchUser = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee7(q) {
            var url, response;
            return _regeneratorRuntime().wrap(function _callee7$(_context7) {
              while (1) switch (_context7.prev = _context7.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/users/search?q=").concat(q);
                  _context7.next = 3;
                  return this.get(url);
                case 3:
                  response = _context7.sent;
                  return _context7.abrupt("return", response);
                case 5:
                case "end":
                  return _context7.stop();
              }
            }, _callee7, this);
          }));
          function searchUser(_x4) {
            return _searchUser.apply(this, arguments);
          }
          return searchUser;
        }()
      }, {
        key: "setUserFCMToken",
        value: function () {
          var _setUserFCMToken = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee8(token) {
            var url, options, response;
            return _regeneratorRuntime().wrap(function _callee8$(_context8) {
              while (1) switch (_context8.prev = _context8.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/users/firebase-fcm-token");
                  options = {
                    params: {
                      token: token
                    }
                  };
                  _context8.next = 4;
                  return this.post(url, options);
                case 4:
                  response = _context8.sent;
                  return _context8.abrupt("return", response);
                case 6:
                case "end":
                  return _context8.stop();
              }
            }, _callee8, this);
          }));
          function setUserFCMToken(_x5) {
            return _setUserFCMToken.apply(this, arguments);
          }
          return setUserFCMToken;
        }()
      }]);
      return _class;
    }(superclass);
  };

  var CardsAPI = function CardsAPI(superclass) {
    return /*#__PURE__*/function (_superclass) {
      _inherits(_class, _superclass);
      var _super = _createSuper(_class);
      function _class() {
        _classCallCheck(this, _class);
        return _super.apply(this, arguments);
      }
      _createClass(_class, [{
        key: "listCards",
        value: function () {
          var _listCards = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
            var url, response;
            return _regeneratorRuntime().wrap(function _callee$(_context) {
              while (1) switch (_context.prev = _context.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/cards/me");
                  _context.next = 3;
                  return this.get(url);
                case 3:
                  response = _context.sent;
                  return _context.abrupt("return", response);
                case 5:
                case "end":
                  return _context.stop();
              }
            }, _callee, this);
          }));
          function listCards() {
            return _listCards.apply(this, arguments);
          }
          return listCards;
        }()
      }, {
        key: "attachCard",
        value: function () {
          var _attachCard = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(token, cardDetails) {
            var url, options, response;
            return _regeneratorRuntime().wrap(function _callee2$(_context2) {
              while (1) switch (_context2.prev = _context2.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/users/attach-card");
                  options = {
                    params: {
                      token: token,
                      cardDetails: cardDetails
                    }
                  };
                  _context2.next = 4;
                  return this.post(url, options);
                case 4:
                  response = _context2.sent;
                  return _context2.abrupt("return", response);
                case 6:
                case "end":
                  return _context2.stop();
              }
            }, _callee2, this);
          }));
          function attachCard(_x, _x2) {
            return _attachCard.apply(this, arguments);
          }
          return attachCard;
        }()
      }]);
      return _class;
    }(superclass);
  };

  var PaymentMethodsAPI = function PaymentMethodsAPI(superclass) {
    return /*#__PURE__*/function (_superclass) {
      _inherits(_class, _superclass);
      var _super = _createSuper(_class);
      function _class() {
        _classCallCheck(this, _class);
        return _super.apply(this, arguments);
      }
      _createClass(_class, [{
        key: "getPaymentMethodsByCurrency",
        value: function () {
          var _getPaymentMethodsByCurrency = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(currencyId) {
            var url, response;
            return _regeneratorRuntime().wrap(function _callee$(_context) {
              while (1) switch (_context.prev = _context.next) {
                case 0:
                  url = "".concat(this.baseUrl, "/payment-methods/").concat(currencyId);
                  _context.next = 3;
                  return this.get(url);
                case 3:
                  response = _context.sent;
                  return _context.abrupt("return", response);
                case 5:
                case "end":
                  return _context.stop();
              }
            }, _callee, this);
          }));
          function getPaymentMethodsByCurrency(_x) {
            return _getPaymentMethodsByCurrency.apply(this, arguments);
          }
          return getPaymentMethodsByCurrency;
        }()
      }]);
      return _class;
    }(superclass);
  };

  var API = /*#__PURE__*/function (_mix$with) {
    _inherits(API, _mix$with);
    var _super = _createSuper(API);
    function API() {
      var _this;
      var kwargs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      _classCallCheck(this, API);
      _this = _super.call(this, kwargs);
      _this.baseUrl = kwargs.baseUrl;
      _this.token = kwargs.token === undefined ? _this.token : kwargs.token;
      return _this;
    }
    _createClass(API, [{
      key: "build",
      value: function () {
        var _build = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(method, url) {
          var options,
            _args = arguments;
          return _regeneratorRuntime().wrap(function _callee$(_context) {
            while (1) switch (_context.prev = _context.next) {
              case 0:
                options = _args.length > 2 && _args[2] !== undefined ? _args[2] : {};
                _context.next = 3;
                return _get(_getPrototypeOf(API.prototype), "build", this).call(this, method, url, options);
              case 3:
                options.headers = options.params !== undefined ? options.headers : {};
                options.kwargs = options.kwargs !== undefined ? options.kwargs : {};
                delete options.kwargs.auth;
                options.headers.token = this.token;
              case 7:
              case "end":
                return _context.stop();
            }
          }, _callee, this);
        }));
        function build(_x, _x2) {
          return _build.apply(this, arguments);
        }
        return build;
      }()
    }], [{
      key: "load",
      value: function () {
        var _load2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
          return _regeneratorRuntime().wrap(function _callee2$(_context2) {
            while (1) switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return load$1();
              case 2:
              case "end":
                return _context2.stop();
            }
          }, _callee2);
        }));
        function load() {
          return _load2.apply(this, arguments);
        }
        return load;
      }()
    }]);
    return API;
  }(mix(API$1)["with"](AccountAPI, CardsAPI, CurrentCommissionAPI, fxRatesAPI, PaymentAPI, PaymentMethodsAPI, TransactionsAPI, UsersAPI, currenciesAPI));

  exports.API = API;
  exports.AccountAPI = AccountAPI;
  exports.PaymentAPI = PaymentAPI;
  exports.TransactionsAPI = TransactionsAPI;
  exports.UsersAPI = UsersAPI;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=lombongo-core-api.umd.js.map
