export const AccountAPI = superclass =>
    class extends superclass {
        async sendMoney({ amount, accountNumber, recieverAccount, deviceFingerprint } = {}) {
            const url = `${this.baseUrl}/accounts/${recieverAccount}/send`;
            const options = {
                params: {
                    amount: amount,
                    account_number: accountNumber,
                    deviceFingerprint: deviceFingerprint
                }
            };
            const response = await this.post(url, options);
            return response;
        }

        async avatar(uid) {
            const url = `${this.baseUrl}/account/${uid}/avatar`;
            const response = await this.get(url);
            return response;
        }

        async attachCreditCard(card) {
            const url = `${this.baseUrl}/account/credit-card/attach`;
            const options = {
                params: {
                    name: card.name,
                    number: card.number,
                    exp_month: card.expMonth,
                    exp_year: card.exp_year,
                    cvc: card.cvc,
                    commission: card.commission
                }
            };
            const response = await this.post(url, options);
            return response;
        }
    };

export default AccountAPI;
