import { API as BaseAPI, mix, load } from "yonius";

import { AccountAPI } from "./account";
import { currenciesAPI } from "./currencies";
import { CurrentCommissionAPI } from "./current-commission";
import { fxRatesAPI } from "./fx-rate";
import { PaymentAPI } from "./payment";
import { TransactionsAPI } from "./transactions";
import { UsersAPI } from "./users";
import CardsAPI from "./card";
import PaymentMethodsAPI from "./payment-methods";

export class API extends mix(BaseAPI).with(
    AccountAPI,
    CardsAPI,
    CurrentCommissionAPI,
    fxRatesAPI,
    PaymentAPI,
    PaymentMethodsAPI,
    TransactionsAPI,
    UsersAPI,
    currenciesAPI
) {
    constructor(kwargs = {}) {
        super(kwargs);
        this.baseUrl = kwargs.baseUrl;
        this.token = kwargs.token === undefined ? this.token : kwargs.token;
    }

    static async load() {
        await load();
    }

    async build(method, url, options = {}) {
        await super.build(method, url, options);
        options.headers = options.params !== undefined ? options.headers : {};
        options.kwargs = options.kwargs !== undefined ? options.kwargs : {};
        delete options.kwargs.auth;
        options.headers.token = this.token;
    }
}

export default API;
