export const TransactionsAPI = superclass =>
    class extends superclass {
        async getFXConfig(originalCurrency, finalCurrency, amount) {
            const url = `${this.baseUrl}/transactions/sepa/config`;
            const options = {
                params: {
                    originalCurrency: originalCurrency,
                    finalCurrency: finalCurrency,
                    amount: amount
                }
            };
            const response = await this.post(url, options);
            return response;
        }

        async transferCrossCurrency({
            sepaBeneficiaryIban,
            sepaBeneficiaryName,
            sepaBeneficiarySwift,
            originalAmount,
            originalCurrency,
            finalAmount,
            finalCurrency,
            fxRate,
            commission
        } = {}) {
            const url = `${this.baseUrl}/users/send/cross-currency`;
            const options = {
                params: {
                    sepaBeneficiaryIban: sepaBeneficiaryIban,
                    sepaBeneficiaryName: sepaBeneficiaryName,
                    sepaBeneficiarySwift: sepaBeneficiarySwift,
                    originalAmount: originalAmount,
                    originalCurrency: originalCurrency,
                    finalAmount: finalAmount,
                    finalCurrency: finalCurrency,
                    fxRate: fxRate,
                    commission: commission
                }
            };
            const response = await this.post(url, options);
            return response;
        }
    };

export default TransactionsAPI;
