export const UsersAPI = superclass =>
    class extends superclass {
        async createUser(user, deviceFingerprint) {
            const url = `${this.baseUrl}/users`;
            const options = { params: user, deviceFingerprint: deviceFingerprint };
            const response = await this.post(url, options);
            return response;
        }

        async getMyAccounts() {
            const url = `${this.baseUrl}/users/me/accounts`;
            const response = await this.get(url);
            return response;
        }

        async getMyTransactions() {
            const url = `${this.baseUrl}/users/me/transactions`;
            const response = await this.get(url);
            return response;
        }

        async setAvatar(avatarUrl) {
            const url = `${this.baseUrl}/users/avatar`;
            const options = { params: { avatarUrl: avatarUrl } };
            const response = await this.post(url, options);
            return response;
        }

        async getAvatar() {
            const url = `${this.baseUrl}/users/me/avatar`;
            const response = await this.get(url);
            return response;
        }

        async getAllUsers() {
            const url = `${this.baseUrl}/users`;
            const response = await this.get(url);
            return response;
        }

        async searchUser(q) {
            const url = `${this.baseUrl}/users/search?q=${q}`;
            const response = await this.get(url);
            return response;
        }

        async setUserFCMToken(token) {
            const url = `${this.baseUrl}/users/firebase-fcm-token`;
            const options = { params: { token: token } };
            const response = await this.post(url, options);
            return response;
        }
    };

export default UsersAPI;
